package com.ejie.ab39a.control;

import com.ejie.ab39a.service.AccionesPgService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.AccionesPg;

/**
 * AccionesPgController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/accionespg")

public class AccionesPgController {

	private static final Logger logger = LoggerFactory.getLogger(AccionesPgController.class);

	@Autowired
	private AccionesPgService accionesPgService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param codaccionpg
	 *            Integer codaccionpg
	 * @return AccionesPg Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{codaccionpg}", method = RequestMethod.GET)
	public @ResponseBody AccionesPg get(@PathVariable Integer codaccionpg) {
		AccionesPg accionesPg = new AccionesPg();
		accionesPg.setCodaccionpg(codaccionpg);
		accionesPg = this.accionesPgService.find(accionesPg);
		AccionesPgController.logger.info("[GET - findBy_PK] : Obtener AccionesPg por PK");
		return accionesPg;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterAccionesPg
	 *            AccionesPg Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<AccionesPg> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<AccionesPg> getAll(@ModelAttribute AccionesPg filterAccionesPg) {
		AccionesPgController.logger.info("[GET - find_ALL] : Obtener AccionesPg por filtro");
		return this.accionesPgService.findAll(filterAccionesPg, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param accionesPg
	 *            AccionesPg Bean que contiene la informacion a modificar.
	 * @return AccionesPg Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody AccionesPg edit(@RequestBody AccionesPg accionesPg) {
		AccionesPg accionesPgAux = this.accionesPgService.update(accionesPg);
		AccionesPgController.logger.info("[PUT] : AccionesPg actualizado correctamente");
		return accionesPgAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param accionesPg
	 *            AccionesPg Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return AccionesPg Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody AccionesPg add(@RequestBody AccionesPg accionesPg) {
		AccionesPg accionesPgAux = this.accionesPgService.add(accionesPg);
		AccionesPgController.logger.info("[POST] : AccionesPg insertado correctamente");
		return accionesPgAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param codaccionpg
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return AccionesPg Bean eliminado.
	 */
	@RequestMapping(value = "/{codaccionpg}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody AccionesPg remove(@PathVariable Integer codaccionpg) {
		AccionesPg accionesPg = new AccionesPg();
		accionesPg.setCodaccionpg(codaccionpg);
		this.accionesPgService.remove(accionesPg);
		AccionesPgController.logger.info("[DELETE] : AccionesPg borrado correctamente");
		return accionesPg;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		AccionesPgController.logger.info("[GET - View] : accionespg");
		return "accionespg";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterAccionesPg
	 *            AccionesPg Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<AccionesPg> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<AccionesPg> filter(
			@RequestJsonBody(param = "filter") AccionesPg filterAccionesPg,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		AccionesPgController.logger.info("[POST - filter] : Obtener AccionesPgs");
		return this.accionesPgService.filter(filterAccionesPg, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterAccionesPg
	 *            AccionesPg Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") AccionesPg filterAccionesPg,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		AccionesPgController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples AccionesPgs");
		this.accionesPgService.removeMultiple(filterAccionesPg, jqGridRequestDto, false);
		AccionesPgController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
